#define TILESMAX 100
#define TILESWIDTH 2 /* width in bytes */
#define TILESHEIGHT 16 /* in rows */

#define LEVELWIDTHMAX 256
#define LEVELHEIGHTMAX 100

#define RWIDTH   1024 /* Raster 450 pixels wide.  */
#define RHEIGHT  768 /* Raster 250 lines high.   */ 

/* The ViewPort is quite small, and is placed in the middle of the View: */
#define DWIDTH   320 /* Display 200 pixels wide. */ 
#define DHEIGHT  256 /* Display 100 lines high.  */
#define DXOFFSET  0 /* DxOffset 60 pixels.      */
#define DYOFFSET  0 /* DyOffset 50 lines.       */

#define DEPTH      8 /* 3 BitPlanes should be used, gives eight colours. */
#define COLOURS    256

#define PLSPEED		12	/* Geschwindigkeit des PLayers */
#define PLSPEED7	10
#define SPEED      8 /* How many pixels the Raster should be scrolled */
                     /* every time.                                   */
#define SPEED7     7 /* Speed * 0.7 fuers schraeg laufen */
#define STEP		64	/* 4*16 Nach wievielen steps er einen Schritt machen soll*/
#define SCROLLSPEED 16 /* Speed mit der der Bildschirm scrollt */

#define CIAAPRA 0xBFE001 

#define FIRE   1
#define RIGHT  2
#define LEFT   4
#define DOWN   8
#define UP    16

#define PORT1 1
#define PORT2 2

/* Fuer die zweite Bitmap */
#define DEPTH2      8 /* 3 BitPlanes should be used, gives eight colours. */
#define RWIDTH2   320 /* Raster 450 pixels wide.  */
#define RHEIGHT2  200 /* Raster 250 lines high.   */ 

#define AIMLENGTH 50  /* in pixeln */
#define AIMSPEED 4  /* in Grad pro 50tel sekunde */

#define SHOTSMAX 20 
#define SHOTSPEED 48
#define SHOTWIDTH 2
#define SHOTHEIGHT 2

#define ENERGY 5
#define LIFES 3
#define DEAD 40					/* Ticks, die der tote Spieler noch rumliegt */

#define FOESMAX 10			/* Maximale Anzahl der Foes */
#define FOEINTERV 100		/* Ticks die ein Foe zum Nachladen+zielen braucht */
#define FOESHAT 25			/* 15 Ticks die ein Foe zum Zielen braucht */
#define FOEDIST 2400		/* Entfernung * 16 ab der ein Foe einen sieht */
#define FSHOTSPEED 48		/* 32 Geschwindigkeit der Foegeschosse */
#define FOEBLEIBT 200 		/* Ticks die der tote foe liegenbleibt */
#define FOEVANISH 5120	/* 16*Entfernung, die die Foes zum Spieler haben koennen, bevor sie verschwinden */
#define FOEDOORX 2560		/* 16* Entfernung, ab der die Foes aus den doors kommen */
#define FOEDOORY 2048

#define DWELLDELAY 150	/* Abstand zwischen den foes aus den doors in ticks */
#define DWELLFOES 11		/* Anzahl der foes, die aus einer Tuer kommen */

#define MAXVSPRITES 11	/* >= FOESMAX */
#define SDUMPY 280			/* Ypos an der nicht benutzte Sprites dargestelt werden */
#define SFOEHEIGHT 6		/* Hoehe der Foe sprites */
#define KILLBACK 500		/* Max ticks die man nach einem Tod zurueck muss */ 

#define ROT 4

#define BODEN 11

/* Fuer den messagebildschirm */
#define WIDTH3  320 /* 640 pixels wide (high resolution)                */
#define HEIGHT3 200 /* 200 lines high (non interlaced NTSC display)     */ 
#define DEPTH3    3 /* 3 BitPlanes should be used, gives eight colours. */
#define COLOURS3  8 /* 2^3 = 8                                          */
#define MESSAGEWAIT 325 /* Ticks, die der Mesageschirm da bleiben soll */
